/* -*- java -*-
   $Id: Kawari8.java,v 1.3 2006/09/13 14:27:47 admin Exp $
*/
package kawari;
import java.io.*;
import java.util.*;

public class Kawari8 {
    private int context_id = -1;
    // DO NOT CHANGE THIS AFTER INITIALIZATION

	public static final int VERSION = 824; // 修正を忘れない事！

    private static String shioribox_path;
    private static String libkawari_path;
    private static String saori_path;

    static {
		System.loadLibrary("kawari8bridge");
    }

    public Kawari8(File ghostdir) {
		if (shioribox_path == null || libkawari_path == null) {
			throw new RuntimeException(
				"notifyRootDir() hasn't called before the constructor being called. "+
				"It seems this NiseRingo is too old, please update if so.");
		}
		if (saori_path == null) {
			throw new RuntimeException(
				"notifySaoriPath() hasn't called before the constructor being called. "+
				"It seems this NiseRingo is too old, please update if so.");
		}

		Hashtable additional_env = new Hashtable();
		additional_env.put("SAORI_FALLBACK_PATH", saori_path);
		additional_env.put("SAORI_FALLBACK_ALWAYS", "1");
	
		context_id = construct(
			shioribox_path,
			"kawari8",
			libkawari_path,
			additional_env,
			ghostdir.getAbsolutePath());
    }

    public void terminate() {
		destruct(context_id);
		context_id = -1;
    }

    public String request(String request) {
		// Charsetヘッダを付けてリクエスト発行。ちょっと危険だが…
		String temp_str = request.substring(0,request.length()-2) + "Charset: Shift_JIS\r\n\r\n";
		byte[] result;
		try {
			result = request(context_id, temp_str.getBytes("SJIS"));
		} catch (Exception e) {
			throw new RuntimeException("Failed to request.", e);
		}

		// 応答の中からCharsetを見付ける。
		temp_str = new String(result);
		int pos_charset = temp_str.indexOf("Charset:");
		if (pos_charset == -1) {
			return temp_str;
		} else {
			int pos_crlf = temp_str.indexOf("\r\n", pos_charset);
			String charset = temp_str.substring(pos_charset+8, pos_crlf).trim();
			try {
				return new String(result, charset);
			} catch (Exception e) {
				throw new RuntimeException(
					"Failed to parse the response.", e);
			}
		}
    }

    public static String getModuleName() {
		return "\u83ef\u548c\u68a88"; // 華和梨8
    }

    public static String getModuleInfo() {
		return "\u83ef\u548c\u68a88 plugin #" + VERSION + " powered by \u83ef\u548c\u68a8 8.x"+
			"-- http://kawari.sourceforge.net/";
    }

    public static boolean checkIfUsable(File ghost_dir) {
		return (new File(ghost_dir,"kawarirc.kis").exists());
    }

    public static String getPluginType() {
		return "shiori";
    }

    public static String getPluginName() {
		return "\u83ef\u548c\u68a88"; // 華和梨8
    }

    public static void notifyRootDir(File root_dir) {
		File shioribox = new File(root_dir, "shioribox");
		shioribox_path = shioribox.getAbsolutePath();

		File libkawari = new File(root_dir, "libkawari8.bundle");
		libkawari_path = libkawari.getAbsolutePath();
    }

    public static void notifySaoriPath(String path) {
		saori_path = path; // コロン区切りの絶対パス
    }

    protected native synchronized int construct(
		String shioribox_path,
		String shiori_name,
		String shiori_module,
		Hashtable additional_env,
		String ghost_path);
    protected native synchronized void destruct(int context_id);
    protected native synchronized byte[] request(int context_id, byte[] req);
}